Angular ProgressBar Component

The ProgressBar component for Angular represents a widget that visually indicates the progress of a lengthy operation.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<div style="font-size: 13px; font-family: Verdana; float: left;">
  <div style="margin-top: 10px;">Horizontal</div>
  <jqxProgressBar [theme]="'fluent'" #horizontal
                  [width]="250" [height]="30" [value]="50">
  </jqxProgressBar>
  <div style="margin-top: 10px;">Vertical</div>
  <jqxProgressBar [theme]="'fluent'" #vertical
                  [width]="30" [height]="250" [value]="50" [orientation]="'vertical'">
  </jqxProgressBar>
  <br />
  <div>Enter a value between 0 and 100</div>
  <jqxInput [theme]="'fluent'" #ValueInput></jqxInput>
  <!--<input id="ValueInput" type="text" style="margin-top: 5px;" />-->
  <jqxButton [theme]="'fluent'" (onClick)="onClick()">Update</jqxButton>
  <jqxCheckBox [theme]="'fluent'" (onChange)="onCheckBox($event)">
    Show Progress Text
  </jqxCheckBox>
  <jqxCheckBox [theme]="'fluent'" (onChange)="onCustomTextCheckBox($event)">
    Custom Progress Text
  </jqxCheckBox>
</div>
	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, ElementRef } from '@angular/core';

import { jqxButtonComponent, jqxButtonModule } from 'jqwidgets-ng/jqxbuttons';
import { jqxInputComponent, jqxInputModule } from 'jqwidgets-ng/jqxinput';
import { jqxRadioButtonComponent, jqxRadioButtonModule } from 'jqwidgets-ng/jqxradiobutton';

import { jqxProgressBarModule, jqxProgressBarComponent } from 'jqwidgets-ng/jqxprogressbar';

@Component({
    selector: 'app-root',
    imports: [jqxProgressBarModule, jqxRadioButtonModule, jqxInputModule, jqxButtonModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent {
    @ViewChild('horizontal') myHorizontalProgressBar: jqxProgressBarComponent;
    @ViewChild('vertical') myVerticalProgressBar: jqxProgressBarComponent;
    @ViewChild('ValueInput') ValueInputElement: jqxInputComponent;

    valueInput: number;
    isUpdated: boolean = false;

    renderText(text: string): string {
        return "<span class='jqx-rc-all' style='background: #ffe8a6; color: #e53d37; font-style: italic;'>" + text + "</span>";
    }

    getValueInput(): number {
        return parseInt(this.ValueInputElement.val());
    }
    //display: none;
    onClick(): void {
        let value = this.getValueInput();
        if (!isNaN(value)) {
            this.valueInput = value;
            this.myHorizontalProgressBar.val(value);
            this.myVerticalProgressBar.val(value);
            this.isUpdated = true;
        }
    }

    onCheckBox(event: any): void {
        let value = this.getValueInput();
        if (value != null && this.isUpdated) {
            this.myHorizontalProgressBar.value(this.valueInput);
            this.myVerticalProgressBar.value(this.valueInput);
        }

        let isChecked = event.args.checked;
        this.myHorizontalProgressBar.showText(isChecked);
        this.myVerticalProgressBar.showText(isChecked);
    }

    onCustomTextCheckBox(event: any): void {
        let value = this.getValueInput();
        if (value != null && this.isUpdated) {
            this.myHorizontalProgressBar.value(this.valueInput);
            this.myVerticalProgressBar.value(this.valueInput);
        }

        if (event.args.checked) {
            this.myHorizontalProgressBar.renderText(this.renderText);
            this.myVerticalProgressBar.renderText(this.renderText);
        }
        else {
            this.myHorizontalProgressBar.renderText(null);
            this.myVerticalProgressBar.renderText(null);
        }
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

ProgressBar API

API Reference of the jQWidgets ProgressBar component for Angular: ProgressBar API

React UI Components Documentation
ReactJS ProgressBar Component
The ProgressBar component for ReactJS represents a widget that visually indicates the progress of a lengthy operation.
Prerequisites
Refer to ReactJS Getting Started before you start with this help topic.
Configuration
The ProgressBar component for ReactJS requires the following imports.
import React from 'react';import ReactDOM from 'react-dom'; import JqxProgressBar from 'jqwidgets-react/react_jqxprogressbar.js';
Then we create our component class. Properties and methods are put as ReactJS props.
class App extends React.Component { render () { return ( <JqxProgressBar width={220} height={22} value={30} /> ) }}
Finally we render our class in the desired HTML element:
ReactDOM.render(<App />, document.getElementById('app'));
Events Methods & Properties
In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:
<JqxProgressBar ref='myProgressBar' width={220} height={22}..... />
Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.
class App extends React.Component { componentDidMount() { //your logic } render () { return ( .... ) }};
Events
The valueChanged event is triggered when the value is changed.
The following example demonstrates how to add an event listener:
componentDidMount (){ this.refs.myProgressBar.on('valueChanged', (event) => { //your logic }); }
Methods & Properties
This is how you call methods & props:
Every component have a method setOptions which accepts a object as an argument. This object contains component settings.
Every component also have a method getOptions which returns a object containing the component settings.
ProgressBar Examples
Overview
The following example demonstrates how to create a ProgressBar component.
Disabled ProgressBar
The following example demonstrates how to disable the ProgressBar component.

Vue UI Components Documentation

Vue ProgressBar Component

The ProgressBar component for Vue represents a widget that visually indicates the progress of a lengthy operation.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The ProgressBar component for Vue requires the following import:

import JqxProgressBar from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxprogressbar.vue';

Add the jqxProgressBar component to the components section of the the Vue class:

 components: {
JqxProgressBar
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxProgressBar/>

<template>
<JqxProgressBar :width="width" :height="height"
:min="min" :max="max" :value="value">
</JqxProgressBar>
</template>

Properties

The properties of the <JqxProgressBar/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
width: 300,
height: 30,
min: 0,
max: 100,
value: 50
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxProgressBar @invalidvalue="onInvalidValue()" 
:width="width" :height="height"
:min="min" :max="max" :value="value">
</JqxProgressBar>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onInvalidValue: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxProgressBar ref="progressbar"></JqxProgressBar>

Here how you can use a component's method:

this.$refs.progressbar.val();

methods: {
// Add here all used callbacks and/or events
onInvalidValue: function () {
// Do something...
this.refs.progressbar.val(0);
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxProgressBar ref="progressbar" @invalidvalue="onInvalidValue()"
:width="width" :height="height"
:min="min" :max="max" :value="value">
</JqxProgressBar>
</template>
<script>
// Import the components that will be used
import JqxProgressBar from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxprogressbar.vue';
export default {
components: {
// Adding imported widgets here
JqxProgressBar
},
data: function () {
// Define properties which will use in the widget
return {
width: 300,
height: 30,
min: 0,
max: 100,
value: 50
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onInvalidValue: function () {
// Do something...
this.refs.progressbar.val(0);
}
}
}
</script>
<style>
</style>

ProgressBar Example

<template>
<div>
<div style="margin-top: 10px">Horizontal</div>
<JqxProgressBar ref="myProgressBar"
:width="250" :height="30" :value="0" :showText="true" :orientation="'horizontal'"
:renderText="renderText" :colorRanges="horizontalColorRanges">
</JqxProgressBar>
<div style="margin-top: 10px">Vertical</div>
<JqxProgressBar ref="myVerticalProgressBar"
:width="30" :height="250" :value="0" :showText="true" :orientation="'vertical'"
:renderText="renderText" :colorRanges="verticalColorRanges">
</JqxProgressBar>
</div>
</template>
<script>
import JqxProgressBar from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxprogressbar.vue';
export default {
components: {
JqxProgressBar
},
data: function () {
return {
horizontalColorRanges: [{ stop: 20, color: '#33b5e5' }, { stop: 50, color: '#98ca00' }, { stop: 80, color: '#ff4444' }, { stop: 100, color: '#aa66cc' }],
verticalColorRanges: [{ stop: 40, color: '#f0ad4e' }, { stop: 59, color: '#5bc0de' }, { stop: 70, color: '#5cb85c' }, { stop: 100, color: '#d9534f' }],
renderText: (text, value) => {
if (value < 60) {
return '<span class="jqx-rc-all" style="color: #333;">' + text + '</span>';
}
return '<span class="jqx-rc-all" style="color: #fff;">' + text + '</span>';
}
}
},
mounted: function () {
let value = 0;
let interval = setInterval(_ => {
value++;
if (value == 100) {
clearInterval(interval);
}
this.$refs.myProgressBar.val(value);
this.$refs.myVerticalProgressBar.val(value);
}, 20);
}
}
</script>
<style>
</style>

Run Code